Agenda for London
=======

Table of Contents
-----
<!-- TOC START min:1 max:2 link:true asterisk:false update:true -->
- [Arrivals and Departures](#arrivals-and-departures)
  - [General Notes](#general-notes)
- [Daily Agenda](#daily-agenda)
  - [Sunday 20.10](#sunday-2010)
  - [Monday 21.10](#monday-2110)
  - [Tuesday 22.10](#tuesday-2210)
  - [Wednesday 23.10](#wednesday-2310)
  - [Thursday 24.10](#thursday-2410)
  - [Friday 25.10](#friday-2510)
  - [Saturday 26.10](#saturday-2610)
- [Summary of Time](#summary-of-time)
<!-- TOC END -->

# Arrivals and Departures

At Location estimates (sorted by arrival time)

| Name       |  Date-Time  |  Date-Time  |
|------------|-------------|-------------|
|**Ben**     |20.10-1500   |26.10-1330   |
|**Mokhtar** |    `*`      |    `*`      |
|**Martin**  |20.10-1545   |26.10-1330   |
|**Paul**    |21.10-1000   |25.10-1700   |
|**Bedeho**  |21.10-1000   |26.10-0730   |
|**Alex**    |21.10-1200   |26.10-1330   |

- `*` *Mokhtar* is having logistics issues, and will not make it

## General Notes
- **All times in London Time (UTC/GMT+0100)**
- The **start** time of the items on each daily agenda is intended to be quite "firm"
- The **end** times of each are more flexible. If we finalize earlier -> "Autonomous work"
- If *member* has an errand, or something they want to in a block denoted "Autonomous work", feel free to ask.
- The blocks which includes "fun" is your own time. After **2100**, there is no pressure to work.

# Daily Agenda

## Sunday 20.10

- **Present:**
  - `Ben`
  - `Martin ~1545`

### Agenda
- **1500**
  - Get keys, information, sign, etc.
  - Handle luggage, and start moving furniture to clear space
  - Get confirmation on delivery.
- **1600-1800**
  - Receive delivery of furniture
  - Set up and arrange desks, chairs, whiteboards
  - Do inventory -> gather list work related items needed
- **When done**
  - Buy groceries for the evening, and breakfast
  - If possible, acquire items on list (most likely Monday morning)
  - Dinner at restaurant/takeaway

## Monday 21.10

- **Present:**
  - `Ben`
  - `Martin`
  - `Mokthar??`
- **Arrivals:**
  - `Paul ~09:30`
  - `Bedeho ~10:00`
  - `Alex ~12:00`

### Agenda
- **0800**
  - Breakfast served
- **0900-1300**
  - Finalize preparations
  - Autonomous work while arrivals settle in
- **1300-1400**
  - Lunch - Foodora
- **1400-1800**
  - Go through [Tracking Issues](https://github.com/Joystream/joystream/issues?utf8=%E2%9C%93&q=label%3Arome-testnet+label%3Atracking-issue) (**TR**) 1-8 (*ALL*)
    - *Ben* does "master" notes along the way, but *all* should note down specific decisions regarding their own assigned tasks and priorities
  - Summary and discussion
    - Agree on each team/member **top priority task** (ie. an unchecked box from one of the **TRs**)
    - *Teams/member* to gather/discuss details, and set realistic timelines for this top priority task
  - Each *teams/member* to sketch up their conclusion on the whiteboard. See example below:

| Name       |Mon|Tue|Wed|Thu|Fri|
|------------|---|---|---|---|---|
|**Alex**    |xxx|xxx|xx |   |   |
|**Bedeho**  |xxx|xx |   |   |   |
|**Ben**     |xxx|xx |   |   |   |
|**Martin**  |xxx|x  |   |   |   |
|**Mokhtar** |xxx|xxx|x  |   |   |
|**Paul**    |xxx|   |   |   |   |

**Notes**
- Where `x` denotes a block of time equivalent to 1/3 of a day.
- In this example, *Alex'* assumes to complete his top priority task after 2/3 of Wednesday.

<br>

- **1800-1900**
  - Dinner - Foodora
- **1900-2030**
  - Set realistic goals for what should be achieved during the week.
    - A document compiling all tasks (ie. checkmark boxes from TRs) we hope to complete will be made, and presented on a monitor all week.
    - For each new task completed, *member* will check it off immediately **ALL WEEK**
- **2030-**
  - Autonomous work
  - Fun

## Tuesday 22.10
### Agenda
- **0800**
  - Breakfast served
- **0900-1300**
  - Autonomous work
- **1300-1400**
  - Lunch - Foodora/nearby restaurant
- **1400-1430**
  - Short briefing on progress for each *teams/member* top priority task
    - Adjust if needed
    - If applicable, add new top priority task nr.`n` and alotted time on whiteboard
- **1430-1730**
  - Autonomous work
- **1730-**
  - Prepare for nice meal at nice restaurant

## Wednesday 23.10
### Agenda
- **0800**
  - Breakfast served
- **0900-1300**
  - Autonomous work
- **1300-1430**
  - Lunch - Foodora/nearby restaurant
- **1430-1500**
  - Short briefing on progress for each *teams/member* top priority task
    - Adjust if needed
    - If applicable, add new top priority task nr.`n` and alotted time on whiteboard
- **1500-1830**
  - Autonomous work
- **1830-2000**
  - Dinner - Foodora/nearby restaurant
- **2000-2030**
  - Short briefing on weekly progress
- **2030-**
  - Autonomous work
  - Fun

## Thursday 24.10
### Agenda
- **0800**
  - Breakfast served
- **0900-1300**
  - Autonomous work
- **1300-1430**
  - Lunch - Foodora/nearby restaurant
- **1430-1500**
  - Short briefing on progress for each *teams/member* top priority task
    - Adjust if needed
    - If applicable, add new top priority task nr.`n` and alotted time on whiteboard
- **1500-1830**
  - Autonomous work
- **1830-2000**
  - Dinner - Foodora/nearby restaurant
- **2000-**
  - Informal presentation of plans for `Constantinople`
    - Discuss and highlight potential issues
    - *Ben* to note key decisions/issues/etc.
  - Autonomous work
  - Fun

## Friday 25.10
### Agenda
- **0800**
  - Breakfast served
- **0900-1300**
  - Autonomous work
- **1300-1430**
  - Lunch - Foodora/nearby restaurant
- **1430-1600**
  - Summary of weekly achievements
    - Count and evaluate quantity and quality of checked off boxes vs. goals set on Monday
    - Revisit the [Rome Live Milestones](https://github.com/Joystream/joystream/issues/103), and revise
  - Discussions regarding the value of such a sprint, vs. working as usual will be done the following weeks [all-hands meeting](/README.md#tuesday-all-hands). We can do a brief round, time permitting.
- **1600-1830**
  - Autonomous work
- **1830-2000**
  - Dinner - Foodora/nearby restaurant
- **2000-**
  - Autonomous work
  - Pack up desks/chairs
  - Fun

## Saturday 26.10
### Agenda
- **0700-0800**
  - Breakfast served
  - Have everything ready for furniture pickup
- **0800-1300**
  - Pack and get ready for checkout
    - Fun/Autonomous work
- **1300-**
  - Checkout
  - Lunch for everyone that are available.

# Summary of Time
Note that is assumed all meetings will conclude as scheduled. Most likely, some shift between "Autonomous work" and "Meetings" shoud be expected.

| **Day** | **Aut. Work** | **Meetings** | **Food/fun** | **TOT** |
|---------|---------------|--------------|--------------|---------|
| **Mon** | 4.5           | 5.5          | 3            | 13      |
| **Tue** | 7             | 0.5          | 5.5          | 13      |
| **Wed** | 8             | 1            | 4            | 13      |
| **Thu** | 7.5           | 1.5          | 4            | 13      |
| **Fri** | 7.5           | 1.5          | 4            | 13      |
| **TOT** | 34.5          | 10           | 20.5         | **65**  |
